Merge branch 'master' into 7370-package-install-testing
[arvados-dev.git] / jenkins / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 read -rd "\000" helpmessage <<EOF
6 $(basename $0): Install and test Arvados components.
7
8 Exit non-zero if any tests fail.
9
10 Syntax:
11         $(basename $0) WORKSPACE=/path/to/arvados [options]
12
13 Options:
14
15 --skip FOO     Do not test the FOO component.
16 --only FOO     Do not test anything except the FOO component.
17 --temp DIR     Install components and dependencies under DIR instead of
18                making a new temporary directory. Implies --leave-temp.
19 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
20                Instead, show the path to give as --temp to reuse them in
21                subsequent invocations.
22 --skip-install Do not run any install steps. Just run tests.
23                You should provide GOPATH, GEMHOME, and VENVDIR options
24                from a previous invocation if you use this option.
25 --only-install Run specific install step
26 WORKSPACE=path Arvados source tree to test.
27 CONFIGSRC=path Dir with api server config files to copy into source tree.
28                (If none given, leave config files alone in source tree.)
29 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
30                Restrict apiserver tests to the given file
31 sdk/python_test="--test-suite test.test_keep_locator"
32                Restrict Python SDK tests to the given class
33 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
34                Restrict Workbench tests to the given file
35 services/arv-git-httpd_test="-check.vv"
36                Show all log messages, even when tests pass (also works
37                with services/keepstore_test etc.)
38 ARVADOS_DEBUG=1
39                Print more debug messages
40 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
41                *_test, and other examples shown above.
42
43 Assuming --skip-install is not given, all components are installed
44 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
45 test suites depend on other components being installed, and installing
46 everything tends to be quicker than debugging dependencies.
47
48 As a special concession to the current CI server config, CONFIGSRC
49 defaults to $HOME/arvados-api-server if that directory exists.
50
51 More information and background:
52
53 https://arvados.org/projects/arvados/wiki/Running_tests
54
55 Available tests:
56
57 apps/workbench
58 apps/workbench_benchmark
59 apps/workbench_profile
60 doc
61 services/api
62 services/crunchstat
63 services/dockercleaner
64 services/fuse
65 services/keepproxy
66 services/keepstore
67 services/login-sync
68 services/nodemanager
69 services/arv-git-httpd
70 sdk/cli
71 sdk/pam
72 sdk/python
73 sdk/ruby
74 sdk/go/arvadosclient
75 sdk/go/keepclient
76 sdk/go/streamer
77 tools/keep-rsync
78
79 EOF
80
81 # First make sure to remove any ARVADOS_ variables from the calling
82 # environment that could interfere with the tests.
83 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
84
85 # Reset other variables that could affect our [tests'] behavior by
86 # accident.
87 GITDIR=
88 GOPATH=
89 VENVDIR=
90 VENV3DIR=
91 PYTHONPATH=
92 GEMHOME=
93 PERLINSTALLBASE=
94
95 COLUMNS=80
96
97 skip_install=
98 temp=
99 temp_preserve=
100
101 clear_temp() {
102     if [[ -z "$temp" ]]; then
103         # we didn't even get as far as making a temp dir
104         :
105     elif [[ -z "$temp_preserve" ]]; then
106         rm -rf "$temp"
107     else
108         echo "Leaving behind temp dirs in $temp"
109     fi
110 }
111
112 fatal() {
113     clear_temp
114     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
115     exit 1
116 }
117
118 report_outcomes() {
119     for x in "${successes[@]}"
120     do
121         echo "Pass: $x"
122     done
123
124     if [[ ${#failures[@]} == 0 ]]
125     then
126         echo "All test suites passed."
127     else
128         echo "Failures (${#failures[@]}):"
129         for x in "${failures[@]}"
130         do
131             echo "Fail: $x"
132         done
133     fi
134 }
135
136 exit_cleanly() {
137     trap - INT
138     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
139     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
140     stop_services
141     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
142     report_outcomes
143     clear_temp
144     exit ${#failures}
145 }
146
147 sanity_checks() {
148     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
149         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
150     echo Checking dependencies:
151     echo -n 'virtualenv: '
152     virtualenv --version \
153         || fatal "No virtualenv. Try: apt-get install virtualenv"
154     echo -n 'go: '
155     go version \
156         || fatal "No go binary. See http://golang.org/doc/install"
157     echo -n 'gcc: '
158     gcc --version | egrep ^gcc \
159         || fatal "No gcc. Try: apt-get install build-essential"
160     echo -n 'fuse.h: '
161     find /usr/include -wholename '*fuse/fuse.h' \
162         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
163     echo -n 'pyconfig.h: '
164     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
165         || fatal "No pyconfig.h. Try: apt-get install python-dev"
166     echo -n 'nginx: '
167     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
168         || fatal "No nginx. Try: apt-get install nginx"
169     echo -n 'perl: '
170     perl -v | grep version \
171         || fatal "No perl. Try: apt-get install perl"
172     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
173         echo -n "perl $mod: "
174         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
175             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl"
176     done
177     echo -n 'gitolite: '
178     which gitolite \
179         || fatal "No gitolite. Try: apt-get install gitolite3"
180 }
181
182 rotate_logfile() {
183   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
184   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
185   if [[ -f "$1/$2" ]]; then
186     THEDATE=`date +%Y%m%d%H%M%S`
187     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
188     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
189   fi
190 }
191
192 declare -a failures
193 declare -A skip
194 declare -A testargs
195 skip[apps/workbench_profile]=1
196
197 while [[ -n "$1" ]]
198 do
199     arg="$1"; shift
200     case "$arg" in
201         --help)
202             echo >&2 "$helpmessage"
203             echo >&2
204             exit 1
205             ;;
206         --skip)
207             skipwhat="$1"; shift
208             skip[$skipwhat]=1
209             ;;
210         --only)
211             only="$1"; skip[$1]=""; shift
212             ;;
213         --skip-install)
214             skip_install=1
215             ;;
216         --only-install)
217             skip_install=1
218             only_install="$1"; shift
219             ;;
220         --temp)
221             temp="$1"; shift
222             temp_preserve=1
223             ;;
224         --leave-temp)
225             temp_preserve=1
226             ;;
227         --retry)
228             retry=1
229             ;;
230         *_test=*)
231             suite="${arg%%_test=*}"
232             args="${arg#*=}"
233             testargs["$suite"]="$args"
234             ;;
235         *=*)
236             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
237             ;;
238         *)
239             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
240             exit 1
241             ;;
242     esac
243 done
244
245 start_api() {
246     echo 'Starting API server...'
247     cd "$WORKSPACE" \
248         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
249         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
250         && export ARVADOS_TEST_API_INSTALLED="$$" \
251         && (env | egrep ^ARVADOS)
252 }
253
254 start_nginx_proxy_services() {
255     echo 'Starting keepproxy, arv-git-httpd, and nginx ssl proxy...'
256     cd "$WORKSPACE" \
257         && python sdk/python/tests/run_test_server.py start_keep_proxy \
258         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
259         && python sdk/python/tests/run_test_server.py start_nginx \
260         && export ARVADOS_TEST_PROXY_SERVICES=1
261 }
262
263 stop_services() {
264     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
265         unset ARVADOS_TEST_PROXY_SERVICES
266         cd "$WORKSPACE" \
267             && python sdk/python/tests/run_test_server.py stop_nginx \
268             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
269             && python sdk/python/tests/run_test_server.py stop_keep_proxy
270     fi
271     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
272         unset ARVADOS_TEST_API_HOST
273         cd "$WORKSPACE" \
274             && python sdk/python/tests/run_test_server.py stop
275     fi
276 }
277
278 interrupt() {
279     failures+=("($(basename $0) interrupted)")
280     exit_cleanly
281 }
282 trap interrupt INT
283
284 sanity_checks
285
286 echo "WORKSPACE=$WORKSPACE"
287
288 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
289     # Jenkins expects us to use this by default.
290     CONFIGSRC="$HOME/arvados-api-server"
291 fi
292
293 # Clean up .pyc files that may exist in the workspace
294 cd "$WORKSPACE"
295 find -name '*.pyc' -delete
296
297 if [[ -z "$temp" ]]; then
298     temp="$(mktemp -d)"
299 fi
300
301 # Set up temporary install dirs (unless existing dirs were supplied)
302 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
303 do
304     if [[ -z "${!tmpdir}" ]]; then
305         eval "$tmpdir"="$temp/$tmpdir"
306     fi
307     if ! [[ -d "${!tmpdir}" ]]; then
308         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
309     fi
310 done
311
312 setup_ruby_environment() {
313     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
314       source "$HOME/.rvm/scripts/rvm"
315       using_rvm=true
316     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
317       source "/usr/local/rvm/scripts/rvm"
318       using_rvm=true
319     else
320       using_rvm=false
321     fi
322
323     if [[ "$using_rvm" == true ]]; then
324         # If rvm is in use, we can't just put separate "dependencies"
325         # and "gems-under-test" paths to GEM_PATH: passenger resets
326         # the environment to the "current gemset", which would lose
327         # our GEM_PATH and prevent our test suites from running ruby
328         # programs (for example, the Workbench test suite could not
329         # boot an API server or run arv). Instead, we have to make an
330         # rvm gemset and use it for everything.
331
332         [[ `type rvm | head -n1` == "rvm is a function" ]] \
333             || fatal 'rvm check'
334
335         # Put rvm's favorite path back in first place (overriding
336         # virtualenv, which just put itself there). Ignore rvm's
337         # complaint about not being in first place already.
338         rvm use @default 2>/dev/null
339
340         # Create (if needed) and switch to an @arvados-tests
341         # gemset. (Leave the choice of ruby to the caller.)
342         rvm use @arvados-tests --create \
343             || fatal 'rvm gemset setup'
344
345         rvm env
346     else
347         # When our "bundle install"s need to install new gems to
348         # satisfy dependencies, we want them to go where "gem install
349         # --user-install" would put them. (However, if the caller has
350         # already set GEM_HOME, we assume that's where dependencies
351         # should be installed, and we should leave it alone.)
352
353         if [ -z "$GEM_HOME" ]; then
354             user_gempath="$(gem env gempath)"
355             export GEM_HOME="${user_gempath%%:*}"
356         fi
357         PATH="$(gem env gemdir)/bin:$PATH"
358
359         # When we build and install our own gems, we install them in our
360         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
361         # PATH so integration tests prefer them over other versions that
362         # happen to be installed in $user_gempath, system dirs, etc.
363
364         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
365         PATH="$tmpdir_gem_home/bin:$PATH"
366         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
367
368         echo "Will install dependencies to $(gem env gemdir)"
369         echo "Will install arvados gems to $tmpdir_gem_home"
370         echo "Gem search path is GEM_PATH=$GEM_PATH"
371     fi
372 }
373
374 with_test_gemset() {
375     if [[ "$using_rvm" == true ]]; then
376         "$@"
377     else
378         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
379     fi
380 }
381
382 gem_uninstall_if_exists() {
383     if gem list "$1\$" | egrep '^\w'; then
384         gem uninstall --force --all --executables "$1"
385     fi
386 }
387
388 setup_virtualenv() {
389     local venvdest=$1; shift
390     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
391         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
392     fi
393     "$venvdest/bin/pip" install 'setuptools>=18' 'pip>=7'
394 }
395
396 export PERLINSTALLBASE
397 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
398
399 export GOPATH
400 mkdir -p "$GOPATH/src/git.curoverse.com"
401 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
402     || fatal "symlink failed"
403
404 setup_virtualenv "$VENVDIR" --python python2.7
405 . "$VENVDIR/bin/activate"
406
407 # Needed for run_test_server.py which is used by certain (non-Python) tests.
408 pip freeze 2>/dev/null | egrep ^PyYAML= \
409     || pip install PyYAML >/dev/null \
410     || fatal "pip install PyYAML failed"
411
412 # Preinstall forked version of libcloud, because nodemanager "pip install"
413 # won't pick it up by default.
414 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
415     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
416     || fatal "pip install apache-libcloud failed"
417
418 # Deactivate Python 2 virtualenv
419 deactivate
420
421 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
422 # Otherwise, skip dependent tests.
423 PYTHON3=$(which python3)
424 if [ "0" = "$?" ]; then
425     setup_virtualenv "$VENV3DIR" --python python3
426 else
427     PYTHON3=
428     skip[services/dockercleaner]=1
429     cat >&2 <<EOF
430
431 Warning: python3 could not be found
432 services/dockercleaner install and tests will be skipped
433
434 EOF
435 fi
436
437 # Reactivate Python 2 virtualenv
438 . "$VENVDIR/bin/activate"
439
440 # Note: this must be the last time we change PATH, otherwise rvm will
441 # whine a lot.
442 setup_ruby_environment
443
444 echo "PATH is $PATH"
445
446 if ! which bundler >/dev/null
447 then
448     gem install --user-install bundler || fatal 'Could not install bundler'
449 fi
450
451 checkexit() {
452     if [[ "$1" != "0" ]]; then
453         title "!!!!!! $2 FAILED !!!!!!"
454         failures+=("$2 (`timer`)")
455     else
456         successes+=("$2 (`timer`)")
457     fi
458 }
459
460 timer_reset() {
461     t0=$SECONDS
462 }
463
464 timer() {
465     echo -n "$(($SECONDS - $t0))s"
466 }
467
468 do_test() {
469     while ! do_test_once ${@} && [[ "$retry" == 1 ]]
470     do
471         read -p 'Try again? [Y/n] ' x
472         if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
473         then
474             break
475         fi
476     done
477 }
478
479 do_test_once() {
480     unset result
481     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
482     then
483         title "Running $1 tests"
484         timer_reset
485         if [[ "$2" == "go" ]]
486         then
487             covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
488             coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
489             # We do "go get -t" here to catch compilation errors
490             # before trying "go test". Otherwise, coverage-reporting
491             # mode makes Go show the wrong line numbers when reporting
492             # compilation errors.
493             if [[ -n "${testargs[$1]}" ]]
494             then
495                 # "go test -check.vv giturl" doesn't work, but this
496                 # does:
497                 cd "$WORKSPACE/$1" && \
498                     go get -t "git.curoverse.com/arvados.git/$1" && \
499                     go test ${coverflags[@]} ${testargs[$1]}
500             else
501                 # The above form gets verbose even when testargs is
502                 # empty, so use this form in such cases:
503                 go get -t "git.curoverse.com/arvados.git/$1" && \
504                     go test ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
505             fi
506             result="$?"
507             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
508             rm "$WORKSPACE/tmp/.$covername.tmp"
509         elif [[ "$2" == "pip" ]]
510         then
511             # $3 can name a path directory for us to use, including trailing
512             # slash; e.g., the bin/ subdirectory of a virtualenv.
513             cd "$WORKSPACE/$1" \
514                 && "${3}python" setup.py test ${testargs[$1]}
515         elif [[ "$2" != "" ]]
516         then
517             "test_$2"
518         else
519             "test_$1"
520         fi
521         result=${result:-$?}
522         checkexit $result "$1 tests"
523         title "End of $1 tests (`timer`)"
524         return $result
525     else
526         title "Skipping $1 tests"
527     fi
528 }
529
530 do_install() {
531     if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
532     then
533         title "Running $1 install"
534         timer_reset
535         if [[ "$2" == "go" ]]
536         then
537             go get -t "git.curoverse.com/arvados.git/$1"
538         elif [[ "$2" == "pip" ]]
539         then
540             # $3 can name a path directory for us to use, including trailing
541             # slash; e.g., the bin/ subdirectory of a virtualenv.
542
543             # Need to change to a different directory after creating
544             # the source dist package to avoid a pip bug.
545             # see https://arvados.org/issues/5766 for details.
546
547             # Also need to install twice, because if it believes the package is
548             # already installed, pip it won't install it.  So the first "pip
549             # install" ensures that the dependencies are met, the second "pip
550             # install" ensures that we've actually installed the local package
551             # we just built.
552             cd "$WORKSPACE/$1" \
553                 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
554                 && cd "$WORKSPACE" \
555                 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
556                 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
557         elif [[ "$2" != "" ]]
558         then
559             "install_$2"
560         else
561             "install_$1"
562         fi
563         checkexit $? "$1 install"
564         title "End of $1 install (`timer`)"
565     else
566         title "Skipping $1 install"
567     fi
568 }
569
570 title () {
571     txt="********** $1 **********"
572     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
573 }
574
575 bundle_install_trylocal() {
576     (
577         set -e
578         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
579         if ! bundle install --local --no-deployment; then
580             echo "(Running bundle install again, without --local.)"
581             bundle install --no-deployment
582         fi
583         bundle package --all
584     )
585 }
586
587 install_doc() {
588     cd "$WORKSPACE/doc" \
589         && bundle_install_trylocal \
590         && rm -rf .site
591 }
592 do_install doc
593
594 install_gem() {
595     gemname=$1
596     srcpath=$2
597     with_test_gemset gem_uninstall_if_exists "$gemname" \
598         && cd "$WORKSPACE/$srcpath" \
599         && bundle_install_trylocal \
600         && gem build "$gemname.gemspec" \
601         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
602 }
603
604 install_ruby_sdk() {
605     install_gem arvados sdk/ruby
606 }
607 do_install sdk/ruby ruby_sdk
608
609 install_perl_sdk() {
610     cd "$WORKSPACE/sdk/perl" \
611         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
612         && make install INSTALLDIRS=perl
613 }
614 do_install sdk/perl perl_sdk
615
616 install_cli() {
617     install_gem arvados-cli sdk/cli
618 }
619 do_install sdk/cli cli
620
621 install_login-sync() {
622     install_gem arvados-login-sync services/login-sync
623 }
624 do_install services/login-sync login-sync
625
626 # Install the Python SDK early. Various other test suites (like
627 # keepproxy) bring up run_test_server.py, which imports the arvados
628 # module. We can't actually *test* the Python SDK yet though, because
629 # its own test suite brings up some of those other programs (like
630 # keepproxy).
631 declare -a pythonstuff
632 pythonstuff=(
633     sdk/pam
634     sdk/python
635     services/fuse
636     services/nodemanager
637     )
638 for p in "${pythonstuff[@]}"
639 do
640     do_install "$p" pip
641 done
642 if [ -n "$PYTHON3" ]; then
643     do_install services/dockercleaner pip "$VENV3DIR/bin/"
644 fi
645
646 install_apiserver() {
647     cd "$WORKSPACE/services/api" \
648         && RAILS_ENV=test bundle_install_trylocal
649
650     rm -f config/environments/test.rb
651     cp config/environments/test.rb.example config/environments/test.rb
652
653     if [ -n "$CONFIGSRC" ]
654     then
655         for f in database.yml application.yml
656         do
657             cp "$CONFIGSRC/$f" config/ || fatal "$f"
658         done
659     fi
660
661     # Fill in a random secret_token and blob_signing_key for testing
662     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
663     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
664
665     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
666     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
667
668     # Set up empty git repo (for git tests)
669     GITDIR=$(mktemp -d)
670     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
671
672     rm -rf $GITDIR
673     mkdir -p $GITDIR/test
674     cd $GITDIR/test \
675         && git init \
676         && git config user.email "jenkins@ci.curoverse.com" \
677         && git config user.name "Jenkins, CI" \
678         && touch tmp \
679         && git add tmp \
680         && git commit -m 'initial commit'
681
682     # Clear out any lingering postgresql connections to the test
683     # database, so that we can drop it. This assumes the current user
684     # is a postgresql superuser.
685     cd "$WORKSPACE/services/api" \
686         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
687         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
688
689     cd "$WORKSPACE/services/api" \
690         && RAILS_ENV=test bundle exec rake db:drop \
691         && RAILS_ENV=test bundle exec rake db:setup \
692         && RAILS_ENV=test bundle exec rake db:fixtures:load
693 }
694 do_install services/api apiserver
695
696 declare -a gostuff
697 gostuff=(
698     sdk/go/arvadosclient
699     sdk/go/streamer
700     services/arv-git-httpd
701     services/crunchstat
702     services/keepstore
703     sdk/go/keepclient
704     services/keepproxy
705     services/datamanager/summary
706     services/datamanager/collection
707     services/datamanager
708     tools/keep-rsync
709     )
710 for g in "${gostuff[@]}"
711 do
712     do_install "$g" go
713 done
714
715 install_workbench() {
716     cd "$WORKSPACE/apps/workbench" \
717         && mkdir -p tmp/cache \
718         && RAILS_ENV=test bundle_install_trylocal
719 }
720 do_install apps/workbench workbench
721
722 test_doclinkchecker() {
723     (
724         set -e
725         cd "$WORKSPACE/doc"
726         ARVADOS_API_HOST=qr1hi.arvadosapi.com
727         # Make sure python-epydoc is installed or the next line won't
728         # do much good!
729         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
730     )
731 }
732 do_test doc doclinkchecker
733
734 stop_services
735
736 test_apiserver() {
737     cd "$WORKSPACE/services/api" \
738         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
739 }
740 do_test services/api apiserver
741
742 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
743 # because we don't need to start up the api server for subsequent tests.
744 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
745   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
746   exit_cleanly
747 fi
748
749 start_api
750
751 test_ruby_sdk() {
752     cd "$WORKSPACE/sdk/ruby" \
753         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
754 }
755 do_test sdk/ruby ruby_sdk
756
757 test_cli() {
758     cd "$WORKSPACE/sdk/cli" \
759         && mkdir -p /tmp/keep \
760         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
761 }
762 do_test sdk/cli cli
763
764 test_login-sync() {
765     cd "$WORKSPACE/services/login-sync" \
766         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
767 }
768 do_test services/login-sync login-sync
769
770 for p in "${pythonstuff[@]}"
771 do
772     do_test "$p" pip
773 done
774 do_test services/dockercleaner pip "$VENV3DIR/bin/"
775
776 for g in "${gostuff[@]}"
777 do
778     do_test "$g" go
779 done
780
781 test_workbench() {
782     start_nginx_proxy_services \
783         && cd "$WORKSPACE/apps/workbench" \
784         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
785 }
786 do_test apps/workbench workbench
787
788 test_workbench_benchmark() {
789     start_nginx_proxy_services \
790         && cd "$WORKSPACE/apps/workbench" \
791         && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
792 }
793 do_test apps/workbench_benchmark workbench_benchmark
794
795 test_workbench_profile() {
796     start_nginx_proxy_services \
797         && cd "$WORKSPACE/apps/workbench" \
798         && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
799 }
800 do_test apps/workbench_profile workbench_profile
801
802 exit_cleanly